<?php

require_once(plugin_dir_path(__FILE__) . 'xwp.php');

class ServerManager {

    // Properties

    //constructor
    public function __construct() {
        
    }

    public function register_apis() {
        global $_xwp;
        // error_log("Registering server manager apis");
        $_xwp->register_route('update-server-settings', array($this,'update_server_settings'));
    }



    // public function update_server_settings(WP_REST_Request $request) {
    //     $new_settings = $request->get_param('_server_settings');
    //     error_log("New settings: " . json_encode($new_settings));
        
    //     // Get existing settings
    //     $existing_settings = get_option('aime_server_settings', array());
    //     error_log("Old settings: " . json_encode($new_settings));

        
    //     // Merge new settings with existing settings
    //     $updated_settings = array_merge($existing_settings, $new_settings);
    //     error_log("Updated settings: " . json_encode($updated_settings));
        
    //     // Update the option with merged settings
    //     update_option('aime_server_settings', $updated_settings);
        
    //     return new WP_REST_Response('Server settings updated successfully', 200);
    // }



    public function update_server_settings(WP_REST_Request $request) {
        global $_xwp;

        $xpell_user_id = $request->get_param('_user_id');
        $channel_id = $request->get_param('_channel_id');
        $space_id = $request->get_param('_');
        $api_key = $request->get_param('_api_key');
        $wp_token = $request->get_param('_wp_token'); //from nonce
        // error_log("Nonce Token: server " . $wp_token);

        if(!$wp_token) {
            return new WP_REST_Response("Invalid token", 401);
        } else {
            $nonce = $_xwp->verify_aime_nonce_token('aime_registration_nonce', $wp_token);
            // wp_verify_nonce($wp_token, 'aime_registration_nonce2');
            // error_log("Nonce nonce" . $nonce);
            if(!$nonce){
                // error_log("Invalid token nonce");
                return new WP_REST_Response("Invalid token nonce", 401);
            }
        }
        
        //save to options
        $aime_settings = get_option('aime_settings');
        $aime_settings['owner_id'] = $xpell_user_id;
        $aime_settings['channel_id'] = $channel_id;
        $aime_settings['space_id'] = $space_id;
        $aime_settings['api_key'] = $api_key;
        //if settings has no server url, set it to default
        if(!isset($aime_settings['server_url'])){
            $aime_settings['server_url'] = $_xwp->aime_server_default_url;
        }
        update_option('aime_settings', $aime_settings);



        return new WP_REST_Response("ok", 200);
    }

    
}

?>
