<?php


require_once(plugin_dir_path(__FILE__) . 'xwp.php');

class UserManager {

    // Properties

    //constructor
    public function __construct() {
        
    }

    public function register_apis() {
        global $_xwp;
        $_xwp->register_route('get-user', array($this,'get_user'));
        $_xwp->register_route('get-users', array($this,"get_users"));
        $_xwp->register_route('get-admin-info', array($this,"get_admin_info"));
        $_xwp->register_route('commit-registration', array($this,"commit_registration"));
    }
    

    public function commit_registration(WP_REST_Request $request) {
        global $_xwp;
            
        $xpell_user_id = $request->get_param('_user_id');
        $channel_id = $request->get_param('_channel_id');
        $space_id = $request->get_param('_space_id');
        $api_key = $request->get_param('_api_key');
        $wp_token = $request->get_param('_wp_token'); //from nonce

        if(!$wp_token) {
            return new WP_REST_Response("Invalid token", 401);
        } else {
            $nonce = $_xwp->verify_aime_nonce_token('aime_registration_nonce', $wp_token);
            
            if(!$nonce) {
                return new WP_REST_Response("Invalid token NF", 401);
            }
        }
        
        //save to options
        $aime_settings = get_option('aime_settings');
        $aime_settings['owner_id'] = $xpell_user_id;
        $aime_settings['channel_id'] = $channel_id;
        $aime_settings['space_id'] = $space_id;
        $aime_settings['api_key'] = $api_key;
        update_option('aime_settings', $aime_settings);

        //log aime settings
        


        return new WP_REST_Response("ok", 200);
    }

    public function get_user(WP_REST_Request $request) {
        $user_id = $request->get_param('_user_id');
        $user = get_user_by('id', $user_id);
        return new WP_REST_Response($user, 200);
    }

    public function get_users(WP_REST_Request $request) {
        $args = ["role" => "subscriber"];

        $users = get_users($args);
    
        // $user_search = new WP_User_Query( $args );

        return new WP_REST_Response($users, 200);

    }
    
    public function get_admin_info(WP_REST_Request $request) {
        $admin_id = get_user_by('email', get_option('admin_email'))->ID;

        $admin_info = [
            'admin_email' => get_option('admin_email'),
            'admin_url' => get_option('siteurl'),
            'blog_name' => get_option('blogname'),
            'first_name' => get_user_meta($admin_id, 'first_name', true),
            'last_name' => get_user_meta($admin_id, 'last_name', true),
            'admin_description' => get_option('blogdescription'),
            'admin_icon' => get_option('site_icon')
        ];
        return new WP_REST_Response($admin_info, 200);
    }

    // public function get_comments(WP_REST_Request $request) {

    //     //write to file
        

    //     $post_id = $request->get_param('_post_id');
    //     $args = array(
    //         // 'post_type' => 'comment',
    //         // 'posts_per_page' => -1
    //         'post_id' => $post_id
    //     );

    //     // if ($post_id) {
    //     //     $args['post_id'] = $post_id;
    //     // }

    //     //$query = new WP_Query($args);
    //     $comments = get_comments($args);//$query->comments;

    //     return new WP_REST_Response($comments, 200);
        
    // }

    // public function delete_comment(WP_REST_Request $request) {
    //     $comment_id = $request->get_param('_comment_id');
    //     $force_delete = $request->get_param('_force_delete');
    //     wp_delete_comment( $comment_id, $force_delete );

    //     return new WP_REST_Response($comment, 200);

        
    // }

    // public function update_comment(WP_REST_Request $request) {
    //     $comment_id = $request->get_param('_comment_id');
    //     $comment_content = $request->get_param('_comment_content');

 
    //     $commentarr = [
    //         'comment_ID'      => $comment_id,
    //         'comment_content' => $comment_content,
    //     ];
        
    //     // update data in the database
    //     wp_update_comment( $commentarr );
    //     return new WP_REST_Response($comment, 200);
        
    // }
}
 
?>
